import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ConsulClusterRootTokenConfig extends cdktf.TerraformMetaArguments {
    /**
    * The ID of the HCP Consul cluster.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/r/consul_cluster_root_token#cluster_id ConsulClusterRootToken#cluster_id}
    */
    readonly clusterId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/r/consul_cluster_root_token#id ConsulClusterRootToken#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/r/consul_cluster_root_token#timeouts ConsulClusterRootToken#timeouts}
    */
    readonly timeouts?: ConsulClusterRootTokenTimeouts;
}
export interface ConsulClusterRootTokenTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/r/consul_cluster_root_token#default ConsulClusterRootToken#default}
    */
    readonly default?: string;
}
export declare function consulClusterRootTokenTimeoutsToTerraform(struct?: ConsulClusterRootTokenTimeoutsOutputReference | ConsulClusterRootTokenTimeouts | cdktf.IResolvable): any;
export declare class ConsulClusterRootTokenTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ConsulClusterRootTokenTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: ConsulClusterRootTokenTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp/r/consul_cluster_root_token hcp_consul_cluster_root_token}
*/
export declare class ConsulClusterRootToken extends cdktf.TerraformResource {
    static readonly tfResourceType = "hcp_consul_cluster_root_token";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp/r/consul_cluster_root_token hcp_consul_cluster_root_token} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ConsulClusterRootTokenConfig
    */
    constructor(scope: Construct, id: string, config: ConsulClusterRootTokenConfig);
    get accessorId(): string;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    get clusterIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get kubernetesSecret(): string;
    get secretId(): string;
    private _timeouts;
    get timeouts(): ConsulClusterRootTokenTimeoutsOutputReference;
    putTimeouts(value: ConsulClusterRootTokenTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | ConsulClusterRootTokenTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
