import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataHcpAwsNetworkPeeringConfig extends cdktf.TerraformMetaArguments {
    /**
    * The ID of the HashiCorp Virtual Network (HVN).
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_network_peering#hvn_id DataHcpAwsNetworkPeering#hvn_id}
    */
    readonly hvnId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_network_peering#id DataHcpAwsNetworkPeering#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The ID of the network peering.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_network_peering#peering_id DataHcpAwsNetworkPeering#peering_id}
    */
    readonly peeringId: string;
    /**
    * If `true`, Terraform will wait for the network peering to reach an `ACTIVE` state before continuing. Default `false`.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_network_peering#wait_for_active_state DataHcpAwsNetworkPeering#wait_for_active_state}
    */
    readonly waitForActiveState?: boolean | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_network_peering#timeouts DataHcpAwsNetworkPeering#timeouts}
    */
    readonly timeouts?: DataHcpAwsNetworkPeeringTimeouts;
}
export interface DataHcpAwsNetworkPeeringTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_network_peering#read DataHcpAwsNetworkPeering#read}
    */
    readonly read?: string;
}
export declare function dataHcpAwsNetworkPeeringTimeoutsToTerraform(struct?: DataHcpAwsNetworkPeeringTimeoutsOutputReference | DataHcpAwsNetworkPeeringTimeouts | cdktf.IResolvable): any;
export declare class DataHcpAwsNetworkPeeringTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataHcpAwsNetworkPeeringTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpAwsNetworkPeeringTimeouts | cdktf.IResolvable | undefined);
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp/d/aws_network_peering hcp_aws_network_peering}
*/
export declare class DataHcpAwsNetworkPeering extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "hcp_aws_network_peering";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp/d/aws_network_peering hcp_aws_network_peering} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataHcpAwsNetworkPeeringConfig
    */
    constructor(scope: Construct, id: string, config: DataHcpAwsNetworkPeeringConfig);
    get createdAt(): string;
    get expiresAt(): string;
    private _hvnId?;
    get hvnId(): string;
    set hvnId(value: string);
    get hvnIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get organizationId(): string;
    get peerAccountId(): string;
    get peerVpcId(): string;
    get peerVpcRegion(): string;
    private _peeringId?;
    get peeringId(): string;
    set peeringId(value: string);
    get peeringIdInput(): string | undefined;
    get projectId(): string;
    get providerPeeringId(): string;
    get selfLink(): string;
    get state(): string;
    private _waitForActiveState?;
    get waitForActiveState(): boolean | cdktf.IResolvable;
    set waitForActiveState(value: boolean | cdktf.IResolvable);
    resetWaitForActiveState(): void;
    get waitForActiveStateInput(): boolean | cdktf.IResolvable | undefined;
    private _timeouts;
    get timeouts(): DataHcpAwsNetworkPeeringTimeoutsOutputReference;
    putTimeouts(value: DataHcpAwsNetworkPeeringTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataHcpAwsNetworkPeeringTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
