import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataHcpAwsTransitGatewayAttachmentConfig extends cdktf.TerraformMetaArguments {
    /**
    * The ID of the HashiCorp Virtual Network (HVN).
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_transit_gateway_attachment#hvn_id DataHcpAwsTransitGatewayAttachment#hvn_id}
    */
    readonly hvnId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_transit_gateway_attachment#id DataHcpAwsTransitGatewayAttachment#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The user-settable name of the transit gateway attachment in HCP.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_transit_gateway_attachment#transit_gateway_attachment_id DataHcpAwsTransitGatewayAttachment#transit_gateway_attachment_id}
    */
    readonly transitGatewayAttachmentId: string;
    /**
    * If `true`, Terraform will wait for the transit gateway attachment to reach an `ACTIVE` state before continuing. Default `false`.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_transit_gateway_attachment#wait_for_active_state DataHcpAwsTransitGatewayAttachment#wait_for_active_state}
    */
    readonly waitForActiveState?: boolean | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_transit_gateway_attachment#timeouts DataHcpAwsTransitGatewayAttachment#timeouts}
    */
    readonly timeouts?: DataHcpAwsTransitGatewayAttachmentTimeouts;
}
export interface DataHcpAwsTransitGatewayAttachmentTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/aws_transit_gateway_attachment#default DataHcpAwsTransitGatewayAttachment#default}
    */
    readonly default?: string;
}
export declare function dataHcpAwsTransitGatewayAttachmentTimeoutsToTerraform(struct?: DataHcpAwsTransitGatewayAttachmentTimeoutsOutputReference | DataHcpAwsTransitGatewayAttachmentTimeouts | cdktf.IResolvable): any;
export declare class DataHcpAwsTransitGatewayAttachmentTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataHcpAwsTransitGatewayAttachmentTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpAwsTransitGatewayAttachmentTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp/d/aws_transit_gateway_attachment hcp_aws_transit_gateway_attachment}
*/
export declare class DataHcpAwsTransitGatewayAttachment extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "hcp_aws_transit_gateway_attachment";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp/d/aws_transit_gateway_attachment hcp_aws_transit_gateway_attachment} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataHcpAwsTransitGatewayAttachmentConfig
    */
    constructor(scope: Construct, id: string, config: DataHcpAwsTransitGatewayAttachmentConfig);
    get createdAt(): string;
    get expiresAt(): string;
    private _hvnId?;
    get hvnId(): string;
    set hvnId(value: string);
    get hvnIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get organizationId(): string;
    get projectId(): string;
    get providerTransitGatewayAttachmentId(): string;
    get selfLink(): string;
    get state(): string;
    private _transitGatewayAttachmentId?;
    get transitGatewayAttachmentId(): string;
    set transitGatewayAttachmentId(value: string);
    get transitGatewayAttachmentIdInput(): string | undefined;
    get transitGatewayId(): string;
    private _waitForActiveState?;
    get waitForActiveState(): boolean | cdktf.IResolvable;
    set waitForActiveState(value: boolean | cdktf.IResolvable);
    resetWaitForActiveState(): void;
    get waitForActiveStateInput(): boolean | cdktf.IResolvable | undefined;
    private _timeouts;
    get timeouts(): DataHcpAwsTransitGatewayAttachmentTimeoutsOutputReference;
    putTimeouts(value: DataHcpAwsTransitGatewayAttachmentTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataHcpAwsTransitGatewayAttachmentTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
