import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataHcpConsulAgentKubernetesSecretConfig extends cdktf.TerraformMetaArguments {
    /**
    * The ID of the HCP Consul cluster.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/consul_agent_kubernetes_secret#cluster_id DataHcpConsulAgentKubernetesSecret#cluster_id}
    */
    readonly clusterId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/consul_agent_kubernetes_secret#id DataHcpConsulAgentKubernetesSecret#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/consul_agent_kubernetes_secret#timeouts DataHcpConsulAgentKubernetesSecret#timeouts}
    */
    readonly timeouts?: DataHcpConsulAgentKubernetesSecretTimeouts;
}
export interface DataHcpConsulAgentKubernetesSecretTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/consul_agent_kubernetes_secret#default DataHcpConsulAgentKubernetesSecret#default}
    */
    readonly default?: string;
}
export declare function dataHcpConsulAgentKubernetesSecretTimeoutsToTerraform(struct?: DataHcpConsulAgentKubernetesSecretTimeoutsOutputReference | DataHcpConsulAgentKubernetesSecretTimeouts | cdktf.IResolvable): any;
export declare class DataHcpConsulAgentKubernetesSecretTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataHcpConsulAgentKubernetesSecretTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpConsulAgentKubernetesSecretTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp/d/consul_agent_kubernetes_secret hcp_consul_agent_kubernetes_secret}
*/
export declare class DataHcpConsulAgentKubernetesSecret extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "hcp_consul_agent_kubernetes_secret";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp/d/consul_agent_kubernetes_secret hcp_consul_agent_kubernetes_secret} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataHcpConsulAgentKubernetesSecretConfig
    */
    constructor(scope: Construct, id: string, config: DataHcpConsulAgentKubernetesSecretConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    get clusterIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get secret(): string;
    private _timeouts;
    get timeouts(): DataHcpConsulAgentKubernetesSecretTimeoutsOutputReference;
    putTimeouts(value: DataHcpConsulAgentKubernetesSecretTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataHcpConsulAgentKubernetesSecretTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
