import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataHcpConsulClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * The ID of the HCP Consul cluster.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/consul_cluster#cluster_id DataHcpConsulCluster#cluster_id}
    */
    readonly clusterId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/consul_cluster#id DataHcpConsulCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/consul_cluster#timeouts DataHcpConsulCluster#timeouts}
    */
    readonly timeouts?: DataHcpConsulClusterTimeouts;
}
export interface DataHcpConsulClusterTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/consul_cluster#default DataHcpConsulCluster#default}
    */
    readonly default?: string;
}
export declare function dataHcpConsulClusterTimeoutsToTerraform(struct?: DataHcpConsulClusterTimeoutsOutputReference | DataHcpConsulClusterTimeouts | cdktf.IResolvable): any;
export declare class DataHcpConsulClusterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataHcpConsulClusterTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpConsulClusterTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp/d/consul_cluster hcp_consul_cluster}
*/
export declare class DataHcpConsulCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "hcp_consul_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp/d/consul_cluster hcp_consul_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataHcpConsulClusterConfig
    */
    constructor(scope: Construct, id: string, config: DataHcpConsulClusterConfig);
    get autoHvnToHvnPeering(): cdktf.IResolvable;
    get cloudProvider(): string;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    get clusterIdInput(): string | undefined;
    get connectEnabled(): cdktf.IResolvable;
    get consulAutomaticUpgrades(): cdktf.IResolvable;
    get consulCaFile(): string;
    get consulConfigFile(): string;
    get consulPrivateEndpointUrl(): string;
    get consulPublicEndpointUrl(): string;
    get consulSnapshotInterval(): string;
    get consulSnapshotRetention(): string;
    get consulVersion(): string;
    get datacenter(): string;
    get hvnId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get organizationId(): string;
    get primaryLink(): string;
    get projectId(): string;
    get publicEndpoint(): cdktf.IResolvable;
    get region(): string;
    get scale(): number;
    get selfLink(): string;
    get size(): string;
    get state(): string;
    get tier(): string;
    private _timeouts;
    get timeouts(): DataHcpConsulClusterTimeoutsOutputReference;
    putTimeouts(value: DataHcpConsulClusterTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataHcpConsulClusterTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
