import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataHcpConsulVersionsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/consul_versions#id DataHcpConsulVersions#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/consul_versions#timeouts DataHcpConsulVersions#timeouts}
    */
    readonly timeouts?: DataHcpConsulVersionsTimeouts;
}
export interface DataHcpConsulVersionsTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/consul_versions#default DataHcpConsulVersions#default}
    */
    readonly default?: string;
}
export declare function dataHcpConsulVersionsTimeoutsToTerraform(struct?: DataHcpConsulVersionsTimeoutsOutputReference | DataHcpConsulVersionsTimeouts | cdktf.IResolvable): any;
export declare class DataHcpConsulVersionsTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataHcpConsulVersionsTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpConsulVersionsTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp/d/consul_versions hcp_consul_versions}
*/
export declare class DataHcpConsulVersions extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "hcp_consul_versions";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp/d/consul_versions hcp_consul_versions} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataHcpConsulVersionsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataHcpConsulVersionsConfig);
    get available(): string[];
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get preview(): string[];
    get recommended(): string;
    private _timeouts;
    get timeouts(): DataHcpConsulVersionsTimeoutsOutputReference;
    putTimeouts(value: DataHcpConsulVersionsTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataHcpConsulVersionsTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
