import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataHcpHvnPeeringConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
    * The unique URL of one of the HVNs being peered.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn_peering_connection#hvn_1 DataHcpHvnPeeringConnection#hvn_1}
    */
    readonly hvn1: string;
    /**
    * The unique URL of one of the HVNs being peered.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn_peering_connection#hvn_2 DataHcpHvnPeeringConnection#hvn_2}
    */
    readonly hvn2: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn_peering_connection#id DataHcpHvnPeeringConnection#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The ID of the peering connection.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn_peering_connection#peering_id DataHcpHvnPeeringConnection#peering_id}
    */
    readonly peeringId: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn_peering_connection#timeouts DataHcpHvnPeeringConnection#timeouts}
    */
    readonly timeouts?: DataHcpHvnPeeringConnectionTimeouts;
}
export interface DataHcpHvnPeeringConnectionTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn_peering_connection#default DataHcpHvnPeeringConnection#default}
    */
    readonly default?: string;
}
export declare function dataHcpHvnPeeringConnectionTimeoutsToTerraform(struct?: DataHcpHvnPeeringConnectionTimeoutsOutputReference | DataHcpHvnPeeringConnectionTimeouts | cdktf.IResolvable): any;
export declare class DataHcpHvnPeeringConnectionTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataHcpHvnPeeringConnectionTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpHvnPeeringConnectionTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp/d/hvn_peering_connection hcp_hvn_peering_connection}
*/
export declare class DataHcpHvnPeeringConnection extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "hcp_hvn_peering_connection";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp/d/hvn_peering_connection hcp_hvn_peering_connection} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataHcpHvnPeeringConnectionConfig
    */
    constructor(scope: Construct, id: string, config: DataHcpHvnPeeringConnectionConfig);
    get createdAt(): string;
    get expiresAt(): string;
    private _hvn1?;
    get hvn1(): string;
    set hvn1(value: string);
    get hvn1Input(): string | undefined;
    private _hvn2?;
    get hvn2(): string;
    set hvn2(value: string);
    get hvn2Input(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get organizationId(): string;
    private _peeringId?;
    get peeringId(): string;
    set peeringId(value: string);
    get peeringIdInput(): string | undefined;
    get projectId(): string;
    get selfLink(): string;
    get state(): string;
    private _timeouts;
    get timeouts(): DataHcpHvnPeeringConnectionTimeoutsOutputReference;
    putTimeouts(value: DataHcpHvnPeeringConnectionTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataHcpHvnPeeringConnectionTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
