import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataHcpHvnRouteConfig extends cdktf.TerraformMetaArguments {
    /**
    * The `self_link` of the HashiCorp Virtual Network (HVN).
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn_route#hvn_link DataHcpHvnRoute#hvn_link}
    */
    readonly hvnLink: string;
    /**
    * The ID of the HVN route.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn_route#hvn_route_id DataHcpHvnRoute#hvn_route_id}
    */
    readonly hvnRouteId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn_route#id DataHcpHvnRoute#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn_route#timeouts DataHcpHvnRoute#timeouts}
    */
    readonly timeouts?: DataHcpHvnRouteTimeouts;
}
export interface DataHcpHvnRouteTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn_route#default DataHcpHvnRoute#default}
    */
    readonly default?: string;
}
export declare function dataHcpHvnRouteTimeoutsToTerraform(struct?: DataHcpHvnRouteTimeoutsOutputReference | DataHcpHvnRouteTimeouts | cdktf.IResolvable): any;
export declare class DataHcpHvnRouteTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataHcpHvnRouteTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpHvnRouteTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp/d/hvn_route hcp_hvn_route}
*/
export declare class DataHcpHvnRoute extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "hcp_hvn_route";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp/d/hvn_route hcp_hvn_route} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataHcpHvnRouteConfig
    */
    constructor(scope: Construct, id: string, config: DataHcpHvnRouteConfig);
    get createdAt(): string;
    get destinationCidr(): string;
    private _hvnLink?;
    get hvnLink(): string;
    set hvnLink(value: string);
    get hvnLinkInput(): string | undefined;
    private _hvnRouteId?;
    get hvnRouteId(): string;
    set hvnRouteId(value: string);
    get hvnRouteIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get selfLink(): string;
    get state(): string;
    get targetLink(): string;
    private _timeouts;
    get timeouts(): DataHcpHvnRouteTimeoutsOutputReference;
    putTimeouts(value: DataHcpHvnRouteTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataHcpHvnRouteTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
