import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataHcpHvnConfig extends cdktf.TerraformMetaArguments {
    /**
    * The ID of the HashiCorp Virtual Network (HVN).
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn#hvn_id DataHcpHvn#hvn_id}
    */
    readonly hvnId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn#id DataHcpHvn#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn#timeouts DataHcpHvn#timeouts}
    */
    readonly timeouts?: DataHcpHvnTimeouts;
}
export interface DataHcpHvnTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/hvn#default DataHcpHvn#default}
    */
    readonly default?: string;
}
export declare function dataHcpHvnTimeoutsToTerraform(struct?: DataHcpHvnTimeoutsOutputReference | DataHcpHvnTimeouts | cdktf.IResolvable): any;
export declare class DataHcpHvnTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataHcpHvnTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpHvnTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp/d/hvn hcp_hvn}
*/
export declare class DataHcpHvn extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "hcp_hvn";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp/d/hvn hcp_hvn} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataHcpHvnConfig
    */
    constructor(scope: Construct, id: string, config: DataHcpHvnConfig);
    get cidrBlock(): string;
    get cloudProvider(): string;
    get createdAt(): string;
    private _hvnId?;
    get hvnId(): string;
    set hvnId(value: string);
    get hvnIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get organizationId(): string;
    get projectId(): string;
    get providerAccountId(): string;
    get region(): string;
    get selfLink(): string;
    get state(): string;
    private _timeouts;
    get timeouts(): DataHcpHvnTimeoutsOutputReference;
    putTimeouts(value: DataHcpHvnTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataHcpHvnTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
