import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataHcpPackerIterationConfig extends cdktf.TerraformMetaArguments {
    /**
    * The slug of the HCP Packer Registry image bucket to pull from.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/packer_iteration#bucket_name DataHcpPackerIteration#bucket_name}
    */
    readonly bucketName: string;
    /**
    * The channel that points to the version of the image you want.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/packer_iteration#channel DataHcpPackerIteration#channel}
    */
    readonly channel: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/packer_iteration#id DataHcpPackerIteration#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/packer_iteration#timeouts DataHcpPackerIteration#timeouts}
    */
    readonly timeouts?: DataHcpPackerIterationTimeouts;
}
export interface DataHcpPackerIterationTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/packer_iteration#default DataHcpPackerIteration#default}
    */
    readonly default?: string;
}
export declare function dataHcpPackerIterationTimeoutsToTerraform(struct?: DataHcpPackerIterationTimeoutsOutputReference | DataHcpPackerIterationTimeouts | cdktf.IResolvable): any;
export declare class DataHcpPackerIterationTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataHcpPackerIterationTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpPackerIterationTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp/d/packer_iteration hcp_packer_iteration}
*/
export declare class DataHcpPackerIteration extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "hcp_packer_iteration";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp/d/packer_iteration hcp_packer_iteration} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataHcpPackerIterationConfig
    */
    constructor(scope: Construct, id: string, config: DataHcpPackerIterationConfig);
    get authorId(): string;
    private _bucketName?;
    get bucketName(): string;
    set bucketName(value: string);
    get bucketNameInput(): string | undefined;
    private _channel?;
    get channel(): string;
    set channel(value: string);
    get channelInput(): string | undefined;
    get createdAt(): string;
    get fingerprint(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get incrementalVersion(): number;
    get organizationId(): string;
    get projectId(): string;
    get revokeAt(): string;
    get ulid(): string;
    get updatedAt(): string;
    private _timeouts;
    get timeouts(): DataHcpPackerIterationTimeoutsOutputReference;
    putTimeouts(value: DataHcpPackerIterationTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataHcpPackerIterationTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
