import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataHcpVaultClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * The ID of the HCP Vault cluster.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/vault_cluster#cluster_id DataHcpVaultCluster#cluster_id}
    */
    readonly clusterId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/vault_cluster#id DataHcpVaultCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * audit_log_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/vault_cluster#audit_log_config DataHcpVaultCluster#audit_log_config}
    */
    readonly auditLogConfig?: DataHcpVaultClusterAuditLogConfig[] | cdktf.IResolvable;
    /**
    * metrics_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/vault_cluster#metrics_config DataHcpVaultCluster#metrics_config}
    */
    readonly metricsConfig?: DataHcpVaultClusterMetricsConfig[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/vault_cluster#timeouts DataHcpVaultCluster#timeouts}
    */
    readonly timeouts?: DataHcpVaultClusterTimeouts;
}
export interface DataHcpVaultClusterMajorVersionUpgradeConfig {
}
export declare function dataHcpVaultClusterMajorVersionUpgradeConfigToTerraform(struct?: DataHcpVaultClusterMajorVersionUpgradeConfig): any;
export declare class DataHcpVaultClusterMajorVersionUpgradeConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataHcpVaultClusterMajorVersionUpgradeConfig | undefined;
    set internalValue(value: DataHcpVaultClusterMajorVersionUpgradeConfig | undefined);
    get maintenanceWindowDay(): string;
    get maintenanceWindowTime(): string;
    get upgradeType(): string;
}
export declare class DataHcpVaultClusterMajorVersionUpgradeConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataHcpVaultClusterMajorVersionUpgradeConfigOutputReference;
}
export interface DataHcpVaultClusterAuditLogConfig {
}
export declare function dataHcpVaultClusterAuditLogConfigToTerraform(struct?: DataHcpVaultClusterAuditLogConfig | cdktf.IResolvable): any;
export declare class DataHcpVaultClusterAuditLogConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataHcpVaultClusterAuditLogConfig | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpVaultClusterAuditLogConfig | cdktf.IResolvable | undefined);
    get datadogRegion(): string;
    get grafanaEndpoint(): string;
    get grafanaUser(): string;
    get splunkHecendpoint(): string;
}
export declare class DataHcpVaultClusterAuditLogConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataHcpVaultClusterAuditLogConfig[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataHcpVaultClusterAuditLogConfigOutputReference;
}
export interface DataHcpVaultClusterMetricsConfig {
}
export declare function dataHcpVaultClusterMetricsConfigToTerraform(struct?: DataHcpVaultClusterMetricsConfig | cdktf.IResolvable): any;
export declare class DataHcpVaultClusterMetricsConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataHcpVaultClusterMetricsConfig | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpVaultClusterMetricsConfig | cdktf.IResolvable | undefined);
    get datadogRegion(): string;
    get grafanaEndpoint(): string;
    get grafanaUser(): string;
    get splunkHecendpoint(): string;
}
export declare class DataHcpVaultClusterMetricsConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataHcpVaultClusterMetricsConfig[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataHcpVaultClusterMetricsConfigOutputReference;
}
export interface DataHcpVaultClusterTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp/d/vault_cluster#default DataHcpVaultCluster#default}
    */
    readonly default?: string;
}
export declare function dataHcpVaultClusterTimeoutsToTerraform(struct?: DataHcpVaultClusterTimeoutsOutputReference | DataHcpVaultClusterTimeouts | cdktf.IResolvable): any;
export declare class DataHcpVaultClusterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataHcpVaultClusterTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataHcpVaultClusterTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp/d/vault_cluster hcp_vault_cluster}
*/
export declare class DataHcpVaultCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "hcp_vault_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp/d/vault_cluster hcp_vault_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataHcpVaultClusterConfig
    */
    constructor(scope: Construct, id: string, config: DataHcpVaultClusterConfig);
    get cloudProvider(): string;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    get clusterIdInput(): string | undefined;
    get createdAt(): string;
    get hvnId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _majorVersionUpgradeConfig;
    get majorVersionUpgradeConfig(): DataHcpVaultClusterMajorVersionUpgradeConfigList;
    get minVaultVersion(): string;
    get namespace(): string;
    get organizationId(): string;
    get pathsFilter(): string[];
    get primaryLink(): string;
    get projectId(): string;
    get publicEndpoint(): cdktf.IResolvable;
    get region(): string;
    get selfLink(): string;
    get state(): string;
    get tier(): string;
    get vaultPrivateEndpointUrl(): string;
    get vaultPublicEndpointUrl(): string;
    get vaultVersion(): string;
    private _auditLogConfig;
    get auditLogConfig(): DataHcpVaultClusterAuditLogConfigList;
    putAuditLogConfig(value: DataHcpVaultClusterAuditLogConfig[] | cdktf.IResolvable): void;
    resetAuditLogConfig(): void;
    get auditLogConfigInput(): cdktf.IResolvable | DataHcpVaultClusterAuditLogConfig[] | undefined;
    private _metricsConfig;
    get metricsConfig(): DataHcpVaultClusterMetricsConfigList;
    putMetricsConfig(value: DataHcpVaultClusterMetricsConfig[] | cdktf.IResolvable): void;
    resetMetricsConfig(): void;
    get metricsConfigInput(): cdktf.IResolvable | DataHcpVaultClusterMetricsConfig[] | undefined;
    private _timeouts;
    get timeouts(): DataHcpVaultClusterTimeoutsOutputReference;
    putTimeouts(value: DataHcpVaultClusterTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataHcpVaultClusterTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
