import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface HcpProviderConfig {
    /**
    * The OAuth2 Client ID for API operations.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp#client_id HcpProvider#client_id}
    */
    readonly clientId?: string;
    /**
    * The OAuth2 Client Secret for API operations.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp#client_secret HcpProvider#client_secret}
    */
    readonly clientSecret?: string;
    /**
    * Alias name
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/hcp#alias HcpProvider#alias}
    */
    readonly alias?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/hcp hcp}
*/
export declare class HcpProvider extends cdktf.TerraformProvider {
    static readonly tfResourceType = "hcp";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/hcp hcp} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options HcpProviderConfig = {}
    */
    constructor(scope: Construct, id: string, config?: HcpProviderConfig);
    private _clientId?;
    get clientId(): string | undefined;
    set clientId(value: string | undefined);
    resetClientId(): void;
    get clientIdInput(): string | undefined;
    private _clientSecret?;
    get clientSecret(): string | undefined;
    set clientSecret(value: string | undefined);
    resetClientSecret(): void;
    get clientSecretInput(): string | undefined;
    private _alias?;
    get alias(): string | undefined;
    set alias(value: string | undefined);
    resetAlias(): void;
    get aliasInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
